
//	File:			InputHandler.java
//	Author:		Tarek Hassan
//	Date:			04 July 2001
//

import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;
import java.awt.*;

// takes mouse and keyboard input from user and puts appropriate commands in the commands queue
class InputHandler implements MouseInputListener
{

    public Vector m_commands;//= new Vector(5);
    private PlayerCanvas p_canvas;
    private Point user;
    private Point mousePosition;
    public double maxpower = 100; // server defaults assumed (max=100, min=-30)
    public double minpower = -30;
    private double powerScale = 0.5;   // powerScale * distance of mouse click from player = power
    private double power;

    public InputHandler(PlayerCanvas p)
    {
      p_canvas = p;
      m_commands = new Vector(5);
      user = p_canvas.getUserCoordinates();
    }

    
    // returns the distance of the point (x,y) from own player
    private double getDistance(int x, int y)
    {
      user = p_canvas.getUserCoordinates();
      double dist = Math.sqrt(((x - user.x)*(x - user.x))+((y - user.y)*(y - user.y)));
      //System.out.println("Distance = " + dist);
      return dist;
    }

    // returns the angle of the point (x,y) from straight ahead of own player
    private double getAngle(int x, int y)
    {
      user = p_canvas.getUserCoordinates();
      if (y != user.y) {    // to avoid divide by zero
        //System.out.println(user);
        //System.out.println("click @("+x+","+y+")");
        double ang = Math.toDegrees(Math.atan((double)(x-user.x)/(user.y-y)));
        //System.out.println("Angle = " + ang);
        if ((x > user.x)&&(ang < 0)){
          ang += 180;
        }
        if ((x < user.x)&&(ang > 0)){
          ang -= 180;
        }
        if ((x == user.x)&&(y > user.y)){
          ang = 180;
        }
        return ang;
      } else if (x > user.x) {
        return 90;
      } else return -90;
    }

//===========================================================================
// The implementation of MouseInputListener interface

    public void mousePressed(MouseEvent e)
    {
      mousePosition = new Point(e.getX(), e.getY());
      p_canvas.selectObject(mousePosition.x, mousePosition.y);
    }

    public void mouseReleased(MouseEvent e)
    {
    }

    public void mouseClicked(MouseEvent e)
    {
    }

    public void mouseEntered(MouseEvent e)
    {
    }

    public void mouseExited(MouseEvent e)
    {
    }

    public void mouseMoved(MouseEvent e)
    {
    }

    public void mouseDragged(MouseEvent e)
    {
    }

}
